'
'   !------------------------------------------------------------------------!
'   !  Modul: AT_IO.bas                                                      !
'   !------------------------------------------------------------------------!
'   !                                                                        !
'   !  Ein- und Ausgang Interface AT_IO                                      !
'   !  Micro Controller:  ATMEL M128                                         !
'   !  Bentigte Module:                                                     !
'   !                                                                        !
'   !------------------------------------------------------------------------!
'   !  Datum    ! Name        ! Abt.    ! Aenderung                          !
'   !------------------------------------------------------------------------!
'   !  30.01.11 ! CoSoMa      !         ! Erstellung                         !
'   !------------------------------------------------------------------------!
'

$regfile = "m2561def.dat"                                   ' specify the used micro


'##########################################
'Definition von Config
'##########################################

'in order for simulation to work correct, you need to specify the used pins
'for lcd4.lbx, the pins are fixed
'Rs = Portb.0
'Rw = Portb.1 We Dont Use The R / W Option Of The Lcd In This Version So Connect To Ground
' E = PortB.2
'E2 = PortB.3        optional for lcd with 2 chips
'Db4 = PortB.4       the data bits must be in a nibble to save code
'Db5 = PortB.5
'Db6 = PortB.6
'Db7 = PortB.7
Rem config Lcdpin = Pin , Rs = Portb.0 , E = Portb.2 , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Postb.7
Rem Config Lcd = 16 * 2

Rem Ansteuerung der Metamorphosis LCD anzeige
'Config Lcdpin = Pin , Rs = Portc.6 , E = Portc.2 , Db4 = Porta.4 , Db5 = Porta.5 , Db6 = Porta.6 , Db7 = Posta.7
'Config Lcd = 16 * 2
'Config Lcdpin = Pin , Rs = Portb.2 , E = Portb.3 , Db4 = Portb.4 , Db5 = Portb.5 , Db6 = Portb.6 , Db7 = Postb.7
'Config Lcd = 16 * 2
Config Lcdpin = Pin , Rs = Portc.0 , E = Portc.5 , Db4 = Porta.4 , Db5 = Porta.5 , Db6 = Porta.6 , Db7 = Posta.7       'Config Lcd = 16 * 2
Config Lcd = 16 * 2



'##########################################
'Definition von Funktionen und Prozeduren
'##########################################


Declare Sub Init_lcd()
Declare Sub Write_lcd(byval Lcd_param As Integer , Bycal Cmd As Byte)

Declare Sub Show_lcd(byval Zeile As Integer , Byval Spalte As Integer , Text As String )
Declare Sub Clear_lcd(byval Zeile As Integer)

Declare Sub Read_io()                                       'Digitaleingnge
Declare Sub Write_io()                                      'Digitalausgnge

Declare Sub Read_ai()                                       'Analogeingnge

Declare Sub Read_kb()                                       'Tastatur


'##########################################
'Definition von Globalen Variablen
'##########################################

Const On = 1
Const Off = 0

Dim Lcdtext As String * 16

Dim Keyb As Integer

Dim Wahlschalter As Byte



Dim Analog As Byte

Dim Ai00 As Integer
Dim Ai01 As Integer
Dim Ai02 As Integer
Dim Ai03 As Integer
Dim Ai04 As Integer
Dim Ai05 As Integer
Dim Ai06 As Integer
Dim Ai07 As Integer
Dim Ai08 As Integer
Dim Ai09 As Integer
Dim Ai10 As Integer
Dim Ai11 As Integer
Dim Ai12 As Integer
Dim Ai13 As Integer
Dim Ai14 As Integer
Dim Ai15 As Integer


Dim Di00 As Bit                                             'Klemme 47-48
Dim Di01 As Bit                                             'Klemme 47-49
Dim Di02 As Bit                                             'Klemme 50-51
Dim Di03 As Bit                                             'Klemme 50-52
Dim Di04 As Bit
Dim Di05 As Bit
Dim Di06 As Bit
Dim Di07 As Bit

Dim Do00 As Bit
Dim Do01 As Bit
Dim Do02 As Bit
Dim Do03 As Bit
Dim Do04 As Bit
Dim Do05 As Bit
Dim Do06 As Bit
Dim Do07 As Bit


'####################
'Modul Anfangskennung
'####################
Goto Endio


'####################################
'Systemfunktionen fr das LCD
'####################################



Sub Init_lcd()

Porta = 0
Portc.0 = 0
Portc.1 = 0
Portc.5 = 0

Config Porta = Output
Config Pinc.0 = Output
Config Pinc.1 = Output
Config Pinc.5 = Output

Waitms 400

  Porta = &B00000010
  Portc.5 = 1

Waitms 5

  Portc.5 = 0                                               'mit 8-Bit-Command in 4-Bit-Modus umschalten

Waitms 50


  'Display aus
  Lcd_param = &B00001000
  Write_lcd Lcd_param , 0
  Waitms 50

  'Zeilen und Font einstellen
  Lcd_param = &B00101100 :
  Write_lcd Lcd_param , 0
  Waitms 50

  'Display an
  Lcd_param = &B00001100 :
  Write_lcd Lcd_param , 0
  Waitms 50

  'Display lschen
  Lcd_param = &B00000001 :
  Write_lcd Lcd_param , 0
  Waitms 50

  'Auto inkrement
  Lcd_param = &B00000110
  Write_lcd Lcd_param , 0
  Waitms 50

End Sub

Sub Write_lcd(byval Lcd_param As Integer , Byval Cmd As Byte)
  Dim Temp_lcd As Integer

   Portc.0 = Cmd


  'Hi Nibble
  Temp_lcd = Lcd_param
  Shift Temp_lcd , Right , 4

  Porta = Temp_lcd
  Portc.5 = 1
  Waitms 3
  Portc.5 = 0

  'Lo Nibble
  Porta = Lcd_param And &H0F
  Portc.5 = 1
  Waitms 3
  Portc.5 = 0

  'Reset da eventuell gesetzt
  Porta = 0
  Portc.6 = 0
  Portc.0 = 0

End Sub


Sub Show_lcd(byval Zeile As Integer , Byval Spalte As Integerg , Text As String)

'Positioniert die Zeile und Spalte und gibt einen Text aus
 Locate Zeile , Spalte
 Lcd Text


End Sub

Sub Clear_lcd(byval Zeile As Integer)

   If Zeile = 0 Then
     Cls
   Else
     Locate Zeile , 1
     Lcd "                "
   End If



End Sub


'########################################
'Systemfunktionen fr die Folientastatur
'########################################

Sub Read_kb() As Integer

Keyb = 255

'Tastatur aktiv setzen
Config Pinc.4 = Output
Portc.4 = 1

'Alle Ports ausschalten
Porta = 0 : Portc.0 = 0 : Portc.1 = 0 : Portc.2 = 0 : Portc.3 = 0

'Ports fr Tastatur freigeben
Config Porta = Input
Config Pinc.0 = Input : Config Pinc.1 = Input : Config Pinc.2 = Input : Config Pinc.3 = Input




Debounce Pinc.1 , 1 , Key_1
Debounce Pina.5 , 1 , Key_2
Debounce Pina.1 , 1 , Key_3
Debounce Pinc.0 , 1 , Key_4
Debounce Pina.4 , 1 , Key_5
Debounce Pina.0 , 1 , Key_6
Debounce Pinc.3 , 1 , Key_7
Debounce Pina.7 , 1 , Key_8
Debounce Pina.3 , 1 , Key_9
Debounce Pina.6 , 1 , Key_0
Debounce Pinc.2 , 1 , Key_stern
Debounce Pina.2 , 1 , Key_raute



Key_1:
Keyb = 49 : Goto Next_check
Key_2:
Keyb = 50 : Goto Next_check
Key_3:
Keyb = 51 : Goto Next_check
Key_4:
Keyb = 52 : Goto Next_check
Key_5:
Keyb = 53 : Goto Next_check
Key_6:
Keyb = 54 : Goto Next_check
Key_7:
Keyb = 55 : Goto Next_check
Key_8:
Keyb = 56 : Goto Next_check
Key_9:
Keyb = 57 : Goto Next_check
Key_0:
Keyb = 48 : Goto Next_check
Key_stern:
Keyb = 42 : Goto Next_check
Key_raute:
Keyb = 35 : Goto Next_check



Next_check:


'Tastatur inaktiv
Portc.4 = 0
Config Porta = Output
Config Portc = Output


'Porta = 0

'Portc 0# = 0
'Portc 0.1 = 0
'Portc 0.2 = 0
'Portc 0.3 = 0
'Portc 0.4 = 0


End Sub

'########################################
'Systemfunktionen fr Digitaleingnge
'########################################

Sub Read_io()
'Eingnge Init
Porta = 0 : Portc.3 = 0
Config Porta = Input

'Eingnge aktiv setzen
Config Pinc.3 = Output
 Portc.3 = 1                                                'Eingnge Port 12 aktiv setzen

'Kurz warten
Waitms 100

'Eingnge einlesen
Di00 = Pina.0
Di01 = Pina.1
Di02 = Pina.2
Di03 = Pina.3
Di04 = Pina.4 :
Di05 = Pina.5
Di06 = Pina.6
Di07 = Pina.7

'Eingnge wieder inaktiv setzen
Portc.3 = 0



End Sub


'########################################
'Systemfunktionen fr Digitalausgnge
'########################################
'
'
Sub Write_io()

Config Porta = Output



'Ausgnge setzen Gruppe 1
Porta.0 = Do00                                              'Relais 1
Porta.1 = Do01                                              'Relais 2
Porta.2 = Do02                                              'Relais 3
Porta.3 = Do03                                              'Relais 4
Porta.4 = Do04                                              'Relais 5
Porta.5 = Do05                                              'Relais 6
Porta.6 = Do06                                              'Relais 7
Porta.7 = Do07                                              'Beeper

'Ausgnge setzen Gruppe 2
'Portb.7 = Do08
'Portg.1 = Do09
'Portg.3 = Do10
'Portg.4 = Do11
'Porte.7 = Do12
'Portg.2 = Do13
'Portd.7 = Do14
'Portb.0 = Do15


'Ausgabe
Config Pinc.6 = Output
Portc.6 = 1
Waitms 20
Portc.6 = 0                                                 'bergabe an HC573
Porta = 0


End Sub

'########################################
'Systemfunktionen fr Analogeingnge
'########################################


Sub Read_ai()

'1 Gruppe AI00-AI07
'Cpu Pin 21

'==================================


Ai00 = Getadc(0)
Ai01 = Getadc(1)
Ai02 = Getadc(2)
Ai03 = Getadc(3)
Ai04 = Getadc(4)
Ai05 = Getadc(5)
Ai06 = Getadc(6)

Incr Analog
If Analog > 7 Then Analog = 0

If Analog = 0 Then

   Ai07 = Getadc(7) / 4

   If Ai07 <= 4 Then
      Wahlschalter = 1
   End If
   If Ai07 > 4 And Ai07 <= 28 Then
      Wahlschalter = 2
   End If
   If Ai07 > 28 And Ai07 <= 34 Then
      Wahlschalter = 3
   End If
   If Ai07 > 34 And Ai07 <= 46 Then
      Wahlschalter = 4
   End If
   If Ai07 > 46 And Ai07 <= 61 Then
      Wahlschalter = 5
   End If
   If Ai07 > 61 And Ai07 <= 103 Then
      Wahlschalter = 6
   End If
   If Ai07 > 103 And Ai07 <= 130 Then
      Wahlschalter = 7
   End If
   If Ai07 > 130 And Ai07 <= 166 Then
      Wahlschalter = 8
   End If
   If Ai07 > 166 And Ai07 <= 194 Then
      Wahlschalter = 9
   End If
   If Ai07 > 194 And Ai07 <= 224 Then
      Wahlschalter = 10
   End If
   If Ai07 > 224 And Ai07 <= 246 Then
      Wahlschalter = 11
   End If
   If Ai07 > 246 Then
      Wahlschalter = 12
   End If



'Multiplexer
'AI08 aktivieren
Portb.2 = 1 : Portd.4 = 0 : Portd.5 = 0

End If

'2 Gruppe AI08-AI15
'Multiplexer ber Ai07=Getadc(7)
'================================

 'Read Analogeingang 8
 If Analog = 1 Then
  Ai08 = Getadc(7)
 'AI09 aktivieren
  Portb.2 = 0 : Portd.4 = 1 : Portd.5 = 0
 End If

 'Read Analogeingang 9
 If Analog = 2 Then
   Ai09 = Getadc(7)
   'AI10 aktivieren
   Portb.2 = 1 : Portd.4 = 1 : Portd.5 = 0
 End If


 'Read Analogeingang 10
  If Analog = 3 Then
    Ai10 = Getadc(7)
    'AI11 aktivieren
    Portb.2 = 0 : Portd.4 = 0 : Portd.5 = 1
  End If

 'Read Analogeingang 11
  If Analog = 4 Then
    Ai11 = Getadc(7)
    'AI12 aktivieren
    Portb.2 = 1 : Portd.4 = 0 : Portd.5 = 1
  End If

 'Read Analogeingang 12
  If Analog = 5 Then
    Ai12 = Getadc(7)
    'AI13 aktivieren
    Portb.2 = 0 : Portd.4 = 1 : Portd.5 = 1
  End If


 'Read Analogeingang 13
  If Analog = 6 Then
    Ai13 = Getadc(7)
    'AI14 aktivieren
    Portb.2 = 1 : Portd.4 = 1 : Portd.5 = 1
  End If


  'Read Analogeingang 14
  If Analog = 7 Then
    Ai14 = Getadc(7)
    'AI07 aktivieren
    Portb.2 = 0 : Portd.4 = 0 : Portd.5 = 0
  End If



End Sub


'####################
'Modul Endekennung
'####################
Endio: